tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_Firelord_OnLoad");

function CT_RABoss_Firelord_OnLoad()
	CT_RABoss_AddMod("Firelord", CT_RABOSS_FIRELORD_INFO, nil, CT_RABOSS_LOCATIONS_MOLTENCORE);
	
	CT_RABoss_AddEvent("Firelord", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF", CT_RABoss_Firelord_EventHandler);
	
	CT_RABoss_AddDropDownButton("Firelord", { CT_RABOSS_FIRELORD_ALERT_LAVASPAWN, CT_RABOSS_FIRELORD_ALERT_LAVASPAWN_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "alertLavaSpawn", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Firelord", { CT_RABOSS_FIRELORD_TARGET_LAVASPAWN, CT_RABOSS_FIRELORD_TARGET_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "targetLavaSpawn", "CT_RABoss_SetInfo");
	CT_RABoss_AddDropDownButton("Firelord", { CT_RABOSS_FIRELORD_ANNOUNCE_LAVASPAWN, CT_RABOSS_FIRELORD_ANNOUNCE_LAVASPAWN_INFO }, "CT_RABoss_ModInfo", "announceRaidLavaSpawn", "CT_RABoss_SetInfo");
end


function CT_RABoss_Firelord_LavaSpawn_Target()
	if ( UnitName("target") ~= CT_RABOSS_FIRELORD_NAME_LAVASPAWN ) or ( UnitIsCorpse("target") ) then
		TargetByName(CT_RABOSS_FIRELORD_NAME_LAVASPAWN);
	end
end

function CT_RABoss_Firelord_EventHandler(event)
	local firelordOptions = CT_RABoss_Mods["Firelord"];
	if ( not firelordOptions or not firelordOptions["status"] or not firelordOptions.enabled ) then
		return;
	end
	if ( arg1 == CT_RABOSS_FIRELORD_SPELL_LAVASPAWN ) then
		if ( firelordOptions["announceRaidLavaSpawn"] ) or ( firelordOptions["alertLavaSpawn"] ) then
			CT_RABoss_Announce(CT_RABOSS_FIRELORD_MSG_SPAWN, firelordOptions["announceRaidLavaSpawn"]);
			CT_RABoss_PlaySound(3);
		end
		if ( firelordOptions["targetLavaSpawn"] ) then
			CT_RABoss_Schedule("CT_RABoss_Firelord_LavaSpawn_Target", 1);
		end
	end
end
