tinsert(CT_RABoss_ModsToLoad, "CT_RABossSarf_BloodlordMandokir_OnLoad");

CT_RABossSarf_BloodlordMandokir_PreviousTarget = nil;
CT_RABossSarf_BloodlordMandokir_IsWatched = false;

CT_RABossSarf_BloodlordMandokir_FunctionNames = {
	CastPetAction = 1;
	UseAction = 1;
	CastSpell = 2;
	CastSpellByName = 1;
	UseInventoryItem = 1;
	UseContainerItem = 2;
	AttackTarget = 0;
	PetAttack = 0;
};

function CT_RABossSarf_BloodlordMandokir_OnLoad()
	CT_RABoss_AddDropDownButton("Bloodlord Mandokir", { CT_RABOSSSARF_BLMANDOKIR_STOP, CT_RABOSSSARF_BLMANDOKIR_STOP_INFO }, "CT_RABoss_ModInfo", "stopOnWatch", "CT_RABoss_SetInfo");
	CT_RABoss_AddEvent("Bloodlord Mandokir", "CHAT_MSG_MONSTER_YELL", CT_RABossSarf_BloodlordMandokir_EventHandler);
	CT_RABoss_SetVar("Bloodlord Mandokir", "stopOnWatch", 1);

	local paramStr = nil;
	for k, v in CT_RABossSarf_BloodlordMandokir_FunctionNames do
		setglobal("CT_RABossSarf_Saved_"..k, getglobal(k));
		if ( not getglobal("CT_RABossSarf_"..k) ) then
			paramStr = "";
			if ( v > 0 ) then
				paramStr = paramStr.."p1";
			end
			for i = 2, v do paramStr = paramStr..",p"..i; end
			RunScript("function CT_RABossSarf_"..k.."("..paramStr..") if ( CT_RABossSarf_BloodlordMandokir_IsWatched ) then return; end return CT_RABossSarf_Saved_"..v.."("..paramStr.."); end");
		end
		setglobal(v, getglobal("CT_RABossSarf_"..v));
	end
end

function CT_RABossSarf_BloodlordMandokir_NoLongerWatching()
	CT_RABossSarf_BloodlordMandokir_IsWatched = false;
	if ( CT_RABossSarf_BloodlordMandokir_PreviousTarget ) then
		TargetByName(CT_RABossSarf_BloodlordMandokir_PreviousTarget);
		CT_RABossSarf_BloodlordMandokir_PreviousTarget = nil;
	end
end

function CT_RABossSarf_BloodlordMandokir_EventHandler(event)
	if ( not CT_RABoss_Mods["Bloodlord Mandokir"] or not CT_RABoss_Mods["Bloodlord Mandokir"]["status"] or not CT_RABoss_Mods["Bloodlord Mandokir"].enabled ) then
		return;
	end
	if ( event == "CHAT_MSG_MONSTER_YELL" ) and ( string.find(arg1, CT_RABOSS_MANDOKIR_REGEXP) ) and ( CT_RABoss_Mods["Bloodlord Mandokir"]["stopOnWatch"] ) then
		local iStart, iEnd, sPlayer = string.find(arg1, CT_RABOSS_MANDOKIR_REGEXP);
		if ( sPlayer ) and ( sPlayer == UnitName("player") ) then
			CT_RABossSarf_BloodlordMandokir_PreviousTarget = UnitName("target");
			CT_RABossSarf_BloodlordMandokir_StopAttacking();
			CT_RABossSarf_BloodlordMandokir_StopCasting();
			CT_RABossSarf_BloodlordMandokir_IsWatched = true;
			CT_RABoss_Schedule("CT_RABossSarf_BloodlordMandokir_NoLongerWatching", 3);
		end
	end
end

function CT_RABossSarf_BloodlordMandokir_StopAttacking()
	PetStopAttack();
	ClearTarget();
	return true;
end

function CT_RABossSarf_BloodlordMandokir_StopAttacking_Old()
	for i = 1, 120 do
		if ( IsAttackAction(i) ) then
			if ( IsCurrentAction(i) ) then
				AttackTarget();
			end
			return true;
		end
	end
	return false;
end

function CT_RABossSarf_BloodlordMandokir_StopCasting()
	SpellStopCasting();
	SpellStopTargeting();
	return true;
end

